Package ru.bitel.bgbilling.modules.cerbercrypt.common.service

# Interface UserCardService

All Superinterfaces:
  `LoggableService`

public interface UserCardService extends LoggableService

- ## Method Summary

  Modifier and Type
  Method
  Description
  `BigDecimal`
  `checkSubscriptionCost(int cid, List<Integer> ucids, Date date)`
  `void`
  `deleteUserCard(int id)`
  `List<UserCard>`
  `getCardListByObject(int objectId)`
  Список карт, привязанных к объекту.
  `List<IdTitle>`
  `getContractObjects(int contractId)`
  `List<UserCard>`
  `getMultiroomBasecards(int cid, int selfCardId)`
  Получение списка базовых карт для этого договора для заполнения комбобокса базовыми картами (мультирум).
  `MapHolder<String,String>`
  `getSystemInfo()`
  `UserCard`
  `getUserCard(int id)`
  `List<UserCard>`
  `getUserCardList(int cid, boolean slavecardsIncluding)`
  Список карт договора.
  `void`
  `releaseSlave(int cid, int slavecardId)`
  Освободить зависимую карту.
  `void`
  `updateUserCard(UserCard uc)`

  ### Methods inherited from interface ru.bitel.common.model.LoggableService

  `logList`

- ## Method Details

  - ### getUserCardList

    List<UserCard> getUserCardList(int cid, boolean slavecardsIncluding) throws ru.bitel.bgbilling.common.BGException
    Список карт договора. Включая или не включая копии карт, т.е. те карты, у которых назначена какая-либо basecard. Для заполнения таблицы карт в договоре, например, надо все карты, а для комбобоксов выбора карт для изменения подписки, назначения копий карт (не те, что мультирум) итд итп нам надо игнорировать все неосновеные карты.
    Parameters:
      `cid` - контрактИд
      `slavecardsIncluding` - включать ли в том числе "неосновные" карты (т.е. "мультирум копии карт" итд)
    Returns:
      список карт
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### updateUserCard

    void updateUserCard(UserCard uc) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### deleteUserCard

    void deleteUserCard(int id) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getSystemInfo

    MapHolder<String,String> getSystemInfo() throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### checkSubscriptionCost

    BigDecimal checkSubscriptionCost(int cid, List<Integer> ucids, Date date) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getMultiroomBasecards

    List<UserCard> getMultiroomBasecards(int cid, int selfCardId) throws ru.bitel.bgbilling.common.BGException
    Получение списка базовых карт для этого договора для заполнения комбобокса базовыми картами (мультирум).
    Parameters:
      `cid` - контрактИд
      `selfCardId` - ид самой этой карты (чтобы исключить её из списка, ведь она тоже базовая и выбираем мы только базовые, она сама будет в этом же списке)
    Returns:
      список; пустой если нет на договоре подходящих базовых карт или все они переполнены копиями, в том числе если в конфиге вообще всегда стоит ноль для максимума копий.
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### releaseSlave

    void releaseSlave(int cid, int slavecardId) throws ru.bitel.bgbilling.common.BGException
    Освободить зависимую карту. Если это зависимая, то отсоединяем её от основной (например, закрываем мы её).
    Parameters:
      `cid` - договор.
      `slavecardId` - зависимая карта карта (usercardId).
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getCardListByObject

    List<UserCard> getCardListByObject(int objectId) throws ru.bitel.bgbilling.common.BGException
    Список карт, привязанных к объекту.
    Parameters:
      `objectId` - код объекта
    Returns:
      список карт
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getContractObjects

    List<IdTitle> getContractObjects(int contractId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### getUserCard

    UserCard getUserCard(int id) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`